/********************************************
* Mac binary file infomation  ver2.02
*		Copyleft|free 1995-96 tyappe
** MacBinary check
********************************************/

#include	<stdio.h>
#include	<time.h>
#include	"mb.h"
static	void	hedar_print() ;

extern	int	mbchk(mode, rfp, mb)
int	mode ;				/** message out mode **/
FILE	*rfp ;				/** read FP(in) **/
struct	MacBinary2	*mb ;		/** MacBinary information(out) **/
{
	unsigned char	rd[HEDSIZE] ;
	int	i, mb2flg ;
	size_t	rn ;
	unsigned long	fsize ;
	unsigned short	xcrc ;

	(void)fseek(rfp, 0, 2);
	fsize = ftell(rfp);
	rewind(rfp);
	if (fsize < HEDSIZE) {
		if (mode&0x02)
			(void)fprintf(stderr, "%s(header size)\n", MB1ERR) ;
		return (-1) ;
	}
	rn=fread((void*)rd, (size_t)sizeof *rd, (size_t)HEDSIZE, rfp) ;
	if (rn < HEDSIZE) {
		if (mode&0x02)
			(void)fprintf(stderr, "%s\n", RDERR) ;
		return (-1) ;
	}

	if (rd[0]!=0 || rd[1]>FNMAX) {	/* file name length error */
		if (mode&0x02)
			(void)fprintf(stderr, "%s(file name length error)\n", MB1ERR) ;
		return (-1) ;
	}
	for (i=rd[1]; i<63; ++i) {
		if (rd[i+2]!=0) {
			if (mode&0x02)
				(void)fprintf(stderr,
				    "%s(file name section error)\n", MB1ERR) ;
			return (-1) ;
		}
	}

	mb->fdfsize=rd[83]<<24 | rd[84]<<16 | rd[85]<<8 | rd[86] ;
	mb->frfsize=rd[87]<<24 | rd[88]<<16 | rd[89]<<8 | rd[90] ;
#ifdef	DEBUG
	(void)printf("rd[83-]: %02X %02X %02X %02X\n",rd[83],rd[84],rd[85],rd[86]) ;
	(void)printf("rd[87-]: %02X %02X %02X %02X\n",rd[87],rd[88],rd[89],rd[90]) ;
	(void)printf("mb->fdfsize=%d\n", mb->fdfsize) ;
	(void)printf("mb->frfsize=%d\n", mb->frfsize) ;
#endif
	if (HEDSIZE+(mb->fdfsize+ALINE-1)/ALINE*ALINE+(mb->frfsize+ALINE-1)/ALINE*ALINE
	    != fsize) {
		if (mode&0x02)
			(void)fprintf(stderr, "%s(file size error)\n", MB1ERR) ;
		return (-1) ;
	}

	mb2flg=0 ;
	mb->fcrc=rd[124]<<8 | rd[125] ;
	xcrc=calcrc(rd,124) ;
	if (mb->fcrc != xcrc) {
		if (mode&0x02)
			(void)fprintf(stderr, "%s(CRC error)\n", MB2ERR) ;
		++mb2flg ;
	}
	if (rd[122]!=NOWVER || rd[123]!=NOWVER) {
		if (mode&0x02)
			(void)fprintf(stderr, "%s(version error)\n", MB2ERR) ;
		++mb2flg ;
	}

	mb->fnsize=rd[1] ;
	(void)sprintf(mb->fname, "%*.*s", mb->fnsize, mb->fnsize, &rd[2]) ;
	(void)sprintf(mb->ftype, "%4.4s", &rd[65]) ;
	(void)sprintf(mb->fcreator, "%4.4s", &rd[69]) ;
	mb->fmkdate=(rd[91]<<24 | rd[92]<<16 | rd[93]<<8 | rd[94]) ;
	mb->fupdate=(rd[95]<<24 | rd[96]<<16 | rd[97]<<8 | rd[98]) ;
	mb->fflg=rd[73]<<8 | rd[101] ;
	mb->fver1=rd[122] ;
	mb->fver2=rd[123] ;
 
	if (mode&0x01) {
		switch (mb2flg) {
		case 0:
			(void)printf("%s\n", MB2MSG) ;
			break ;
		case 1:
			(void)printf("%s\n", MB3MSG) ;
			break ;
		case 2:
			(void)printf("%s\n", MB1MSG) ;
			break ;
		}
		hedar_print(mb, xcrc) ;
	}
	return 0 ;
}

static	void	hedar_print(mb, xcrc)
struct	MacBinary2	*mb ;
unsigned short	xcrc ;
{
	char	dt[64] ;
	time_t	timwork ;
	struct	tm	*tim ;
	int	i ;

	(void)printf("filename length   :%d Byte\n", mb->fnsize) ;
	(void)printf("filename          :<%s>\n", mb->fname) ;
	(void)printf("type              :<%s>\n", mb->ftype) ;
	(void)printf("creator           :<%s>\n", mb->fcreator) ;
	(void)printf("datafork length   :%d(%d)Byte\n",
	    mb->fdfsize, (mb->fdfsize+ALINE-1)/ALINE*ALINE) ;
	(void)printf("resoucefork length:%d(%d)Byte\n",
	    mb->frfsize, (mb->frfsize+ALINE-1)/ALINE*ALINE) ;
	if (mb->fmkdate<MTIME) {
		(void)sprintf(dt, DTERR) ;
	}
	else {
		timwork=(time_t)(mb->fmkdate-MTIME) ;
		tim=gmtime(&timwork) ;
		(void)sprintf(dt,"%02d/%02d/%02d %02d:%02d:%02d (%s)",
		    tim->tm_year, tim->tm_mon+1, tim->tm_mday,
		    tim->tm_hour, tim->tm_min, tim->tm_sec,
		    week[tim->tm_wday&0x07]) ;
	}
	(void)printf("create date       :%s\n", dt) ;
	if (mb->fupdate<MTIME) {
		(void)sprintf(dt, DTERR) ;
	}
	else {
		timwork=(time_t)(mb->fupdate-MTIME) ;
		tim=gmtime(&timwork) ;
		(void)sprintf(dt,"%02d/%02d/%02d %02d:%02d:%02d (%s)",
		    tim->tm_year, tim->tm_mon+1, tim->tm_mday,
		    tim->tm_hour, tim->tm_min, tim->tm_sec,
		    week[tim->tm_wday&0x07]) ;
	}
	(void)printf("update date       :%s\n", dt) ;
	(void)printf("finder flag       :$%04X\n", mb->fflg) ;
	for (i=0; i<16; ++i) {
		if (mb->fflg & (0x0001<<i)) {
			(void)printf("  (%2d)%s\n", i+1, find[i&0x0F]) ;
		}
	}
	(void)printf("version           :%d,%d\n", mb->fver1, mb->fver2) ;
	(void)printf("CRC(survey)       :$%04X($%04X)\n", mb->fcrc, xcrc) ;
	return ;
}

